function [A]=SOMPerr(D,X,errorGoal,NN3)
%=============================================
% Sparse coding of a group of signals based on a given 
% dictionary and specified number of atoms to use. 
% input arguments: D - the dictionary
%                  X - the signals to represent
%                  errorGoal - the maximal allowed representation error for
%                  each siganl.
%                  NN3 - the number of signal group
% output arguments: A - sparse coefficient matrix.
%=============================================
[n,P]=size(X);
[n,K]=size(D);

E2 = errorGoal * NN3;
maxNumCoef = K;
A = sparse(size(D,2),size(X,2));

for k=1:1:P/NN3,
    x=X(:,(k-1)*NN3+1:k*NN3);
    residual=x;
	indx = [];
	a = [];
	currResNorm2 = sum(sum(residual.^2));
	j = 0;
    while currResNorm2>E2 & j < maxNumCoef,
		j = j+1;
        proj=D'*residual;
        pos=find(sum(abs(proj),2) == max(sum(abs(proj),2)));
        pos=pos(1);
        indx(j)=pos;
        a=pinv(D(:,indx(1:j)))*x;
        residual=x-D(:,indx(1:j))*a;
        currResNorm2 = sum(sum(residual.^2));
   end;
   if (length(indx)>0)
       A(indx,(k-1)*NN3+1:k*NN3)=a;
   end
end;
return;
