function fusionresult = lp_sr_fusion( i1,i2,lplevel,h_rule,bd,blocksize,epsilon)
% i1-- multispectral image
% i2   -- sar image
% lplevel --  lp decomposition level
% h_rule -- fusion rule for high-pass
%          ap == 1: choose max(abs)
%          ap == 2: salience / match measure with threshold == .75 (as proposed by Burt et al)
%          ap == 3: choose max with consistency check (as proposed by Li et al)
%          ap == 4: simple choose max
% bd    -- blockdimension 
% blocksize -- size of block
% epsilon -- construction error threshold

% example: fusion_lpsr = lp_sr_fusion(ms,sar,1,1,8,[8 8],0.01);

fusionresult = zeros(size(i1));

fusionresult(:,:,1) = lp_sr_fusion_singleband( i1(:,:,1),i2,lplevel,h_rule,bd,blocksize,epsilon );
fusionresult(:,:,2) = lp_sr_fusion_singleband( i1(:,:,2),i2,lplevel,h_rule,bd,blocksize,epsilon );
fusionresult(:,:,3) = lp_sr_fusion_singleband( i1(:,:,3),i2,lplevel,h_rule,bd,blocksize,epsilon );

end
