function fusionresult = sprase_fusion_singleband(image,sar,bd,blocksize,epsilon)

% image -- one band of multispectral
% sar   -- sar image
% bd    -- blockdimension 
% blocksize -- size of block
%epsilon -- construction error threshold

[M,N] = size(image);

[vectors1,idx] = my_im2col(image,blocksize,1);
vecOfMeans1 = mean(vectors1);
vectors1 = vectors1 - repmat(vecOfMeans1,size(vectors1,1),1);


vectors2 = my_im2col(sar,blocksize,1);
vecOfMeans2 = mean(vectors2);
vectors2 = vectors2 - repmat(vecOfMeans2,size(vectors2,1),1);


vectors_group = zeros(bd*bd,2);

% DCT   
Pn=ceil(sqrt(bd*bd*4));
DCT=zeros(bd,Pn);
for k=0:1:Pn-1,
    V=cos([0:1:bd-1]'*k*pi/Pn);
    if k>0, V=V-mean(V); end;
    DCT(:,k+1)=V/norm(V);
end;
DCT=kron(DCT,DCT);

% sparse coefficients
alpha_f = zeros(size(DCT,2),size(vectors1,2));
alpha1 = zeros(size(alpha_f));alpha2 = zeros(size(alpha_f));

for i=1:1:size(vectors1,2)
    alpha = zeros(size(DCT,2),1);
    vectors_group = [vectors1(:,i),vectors2(:,i)];
    alpha_group = SOMPerr(DCT,vectors_group,epsilon,2);
    alpha1(:,i) = alpha_group(:,1);alpha2(:,i) = alpha_group(:,2); 
    abs_alpha1 = abs(alpha_group(:,1));abs_alpha2 = abs(alpha_group(:,2));
    index_1 = [find((abs_alpha1 - abs_alpha2)>0);find((abs_alpha1 - abs_alpha2)==0)];
    index_2 = find((abs_alpha2 - abs_alpha1)>0);
    alpha(index_1) = alpha_group(index_1,1);
    alpha(index_2) = alpha_group(index_2,2);
    alpha_f(:,i) =alpha;   
end

% weighted mean
weightedmean = zeros(size(vecOfMeans1));
for j=1:1:size(vectors1,2)
    
    weightedmean(1,j) = 1*vecOfMeans1(1,j) + 0*vecOfMeans2(1,j);

end

% reconstruction
vector_f = DCT*alpha_f + ones(size(vectors1,1),1) * weightedmean;
fusionresult = my_col2im(vector_f,blocksize,[M,N],idx);
end

